package com.logicbig.example;

import javax.persistence.*;
import java.io.File;
import java.util.HashMap;
import java.util.Map;

@Entity
public class Journal {
    @Id
    @GeneratedValue
    private long id;
    @ElementCollection
    @Convert(converter = FileConverter.class, attributeName = "value")
    private Map<String, File> reportMap;

    public void addReport(String description, File file) {
        if (reportMap == null) {
            reportMap = new HashMap<>();
        }
        reportMap.put(description, file);
    }

    @Override
    public String toString() {
        return "Journal{" +
                "id=" + id +
                ", reportMap=" + reportMap +
                '}';
    }
}